## dnscat2 0.07

=== Makefile ===
# Makefile
# By Ron
#
# See LICENSE.md

# Can't use a '#' in the shell command
VERSION=$(shell egrep '^.define VERSION' client/dnscat.c | head -n1 | cut -d\" -f2)

OS=$(shell uname -s)
ARCH=$(shell uname -p | sed 's/x86_64/x64/i' | sed 's/i.86/x86/i')

ifeq ($(OS), Linux)
  RELEASE_FILENAME="dnscat2-$(VERSION)-client-$(ARCH)"
else
  RELEASE_FILENAME="dnscat2-$(VERSION)-client-$(OS)-$(ARCH)"
endif

all:
	@cd client && make
	@echo "Compile complete!"
	@echo "* Client: client/dnscat"
	@echo "* Server: server/dnscat_*.rb"

clean:
	@cd client && make clean

debug:
	@cd client && make debug
	@echo "Debug compile complete!"

release:
	@make clean
	-mkdir dist/
	@cd client && make release
	@mv client/dnscat .
	@strip dnscat
	@tar -cvvjf dist/${RELEASE_FILENAME}.tar.bz2 dnscat
	@echo "*** Release compiled: `pwd`/${RELEASE_FILENAME}"
	@echo "*** By the way, did you update the version number in the server?"
	@echo "Release compile complete!"

source_release:
	@make clean
	-mkdir dist/
	@cp -r client dnscat2_client
	@tar -cvvjf dist/dnscat2-${VERSION}-client-source.tar.bz2 dnscat2_client
	@zip -r dist/dnscat2-${VERSION}-client-source.zip dnscat2_client
	@rm -rf dnscat2_client
	@cp -r server dnscat2_server
	@tar -cvvjf dist/dnscat2-${VERSION}-server.tar.bz2 dnscat2_server
	@zip -r dist/dnscat2-${VERSION}-server.zip dnscat2_server
	@rm -rf dnscat2_server

dnscat:
	@cd client && make dnscat

=== client/Makefile ===
# Makefile
# By Ron Bowes
# Created January, 2013
#
# (See LICENSE.md)
#
# Should work for Linux and BSD make.

CC?=gcc
DEBUG_CFLAGS?=-DTESTMEMORY -Werror -O0
RELEASE_CFLAGS?=-Os
CFLAGS?=--std=c89 -I. -Wall -D_DEFAULT_SOURCE -fstack-protector-all -Wformat -Wformat-security -g
LIBS=-pie -Wl,-z,relro,-z,now

OBJS=controller/packet.o \
		 controller/session.o \
		 controller/controller.o \
		 drivers/driver.o \
		 drivers/command/driver_command.o \
		 drivers/command/command_packet.o \
		 drivers/driver_console.o \
		 drivers/driver_exec.o \
		 drivers/driver_ping.o \
		 libs/buffer.o \
		 libs/crypto/encryptor.o \
		 libs/crypto/micro-ecc/uECC.o \
		 libs/crypto/salsa20.o \
		 libs/crypto/sha3.o \
		 libs/dns.o \
		 libs/ll.o \
		 libs/log.o \
		 libs/memory.o \
		 libs/select_group.o \
		 libs/tcp.o \
		 libs/types.o \
		 libs/udp.o \
		 tunnel_drivers/driver_dns.o \

DNSCAT_DNS_OBJS=${OBJS} dnscat.o

all: dnscat
	@echo "*** Build complete! Run 'make debug' to build a debug version!"

debug: CFLAGS += $(DEBUG_CFLAGS)
debug: dnscat
	@echo "*** Debug build complete"

release: CFLAGS += ${RELEASE_CFLAGS}
release: dnscat

nocrypto: CFLAGS += -DNO_ENCRYPTION
nocrypto: all

remove:
	rm -f /usr/local/bin/dnscat

uninstall: remove

clean:
	-rm -f *.o */*.o */*/*.o */*/*/*.o *.exe *.stackdump dnscat tcpcat test driver_tcp driver_dns
	-rm -rf win32/Debug/
	-rm -rf win32/Release/
	-rm -rf win32/*.ncb
	-rm -rf win32/*.sln
	-rm -rf win32/*.suo
	-rm -rf win32/*.vcproj.*

dnscat: ${DNSCAT_DNS_OBJS}
	${CC} ${CFLAGS} -o dnscat ${DNSCAT_DNS_OBJS}
	@echo "*** dnscat successfully compiled"

COMMANDS=drivers/command/commands_standard.h \
				 drivers/command/commands_tunnel.h

drivers/command/driver_command.o: drivers/command/driver_command.c ${COMMANDS}
	${CC} -c ${CFLAGS} -o drivers/command/driver_command.o drivers/command/driver_command.c

=== debian/changelog ===
dnscat2 (0.07-0kali2) kali-dev; urgency=medium

  * Add a patch to fix issue with ruby2.7

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 04 Sep 2020 15:56:48 +0200

dnscat2 (0.07-0kali1) kali-dev; urgency=medium

  * Initial release (see 6668)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 25 Aug 2020 11:27:16 +0200

=== debian/control ===
Source: dnscat2
Section: net
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.5.0
Homepage: https://github.com/iagox86/dnscat2
Vcs-Browser: https://gitlab.com/kalilinux/packages/dnscat2
Vcs-Git: https://gitlab.com/kalilinux/packages/dnscat2.git
Rules-Requires-Root: no

Package: dnscat2
Architecture: all
Section: metapackages
Depends: ${misc:Depends}, dnscat2-client, dnscat2-server
Description: DNS tunnel (metapackage)
 This tool is designed to create an encrypted command-and-control (C&C) channel
 over the DNS protocol, which is an effective tunnel out of almost every
 network.

Package: dnscat2-client
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dnscat2-server
Description: DNS tunnel, the client part
 This tool is designed to create an encrypted command-and-control (C&C) channel
 over the DNS protocol, which is an effective tunnel out of almost every
 network.
 .
 The client is designed to be run on a compromised machine.

Package: dnscat2-server
Architecture: all
Depends: ${misc:Depends},
 ruby | ruby-interpreter,
 ruby-trollop,
 ruby-salsa20,
 ruby-ecdsa,
 ruby-sha3
Suggests: dnscat2-client
Description: DNS tunnel, the server part
 This tool is designed to create an encrypted command-and-control (C&C) channel
 over the DNS protocol, which is an effective tunnel out of almost every
 network.
 .
 The server is designed to be run on an authoritative DNS server.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_fixperms-indep:
	dh_fixperms
	chmod 644 debian/dnscat2-server/usr/share/dnscat2/dnscat2.rb

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dnscat2-$1.tar.gz%" \
   https://github.com/iagox86/dnscat2/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
